/**
 * Created by Paul on 2015/11/2.
 */

//所有扩展均在L命名空间下
(function () {
    window.LM = window.L = {
        version: "1.0",
        //api列表
        api: ["$namespace", "$package", "Class", "http", "scroll"],
        /**
         * 实现命名空间防止全局变量污染
         * @method $namespace
         * @memberOf L
         * @param {string} name 命名空间名
         * @example
         * L.$namespace("dom")dom为window.dom
         */
        $namespace: function (name) {
            if (!name) {
                return window;
            }

            nsArr = name.split(".");
            var ns = window;

            for (i = 0 , l = nsArr.length; i < l; i++) {
                var n = nsArr[i];
                ns[n] = ns[n] || {};
                ns = ns[n];
            }

            return ns;
        },
        /**
         * 定义闭包
         * @method $package
         * @memberOf L
         * @param {string} ns  命名空间
         * @param {function} func 匿名函数
         * @example
         * L.$package(
         * function (L) {}) L为命名空间;
         */
        $package: function (ns, func) {
            var target;
            //func辩型为function时为匿名闭包
            if (typeof ns == "function") {
                func = ns;
                target = window;
            }
            if (typeof ns == "string") {
                target = this.$namespace(ns);
            }
            if (typeof ns == "object") {
                target = ns;
            }
            func.call(target, this);
        },
        /**
         * 类构造
         * @method Class
         * @memberOf L
         * @param {function}  类构造函数
         * @example
         * L.$package(
         * function (function Dog(){}) {}) Dog为构造函数;
         */
        Class: function () {
            var newClass = function () {
                return new newClass.prototype._init(arguments);
            };
            newClass.prototype = arguments[0];
            newClass.prototype._init = function (arg) {
                this.init.apply(this, arg);
            };
            newClass.prototype._init.prototype = newClass.prototype;

            return newClass;
        },
        //加载模块方法
        request: function () {

        }

    };

})();
L.$package(function (L) {

    //接口后缀
    var suffix = ".action";
    //接口路径 已删除 在leadfund.js里配置
    var path = "/leadbank-gateway-web/";
    //指定域名（可选）已删除 在leadfund.js里配置
    var domain = "" || window.location.origin;
    //开启debug模式,1为打印调用接口和错误和成功,0为关闭
    var debug = 1;
    ////获取当前域名
    //var getDomain = function () {
    //    return
    //};


    //dom操作
    var $ = function (expression) {
        return new _$(expression);
    };
    var _$ = function (expression) {
        var node = {};

        if (typeof expression == "string") {
            node = document.querySelectorAll(expression);
        } else if (typeof expression == "object") {
            node = [expression];
        }
        this.node = node;

    };
    //_$.prototype = new Node();
    _$.prototype.on = function () {
        var _event,_func,_selector,_data={},node = this.node;
        if (typeof node == "string") {
            node = $(node);
        }
        if(typeof arguments[0] =="string" && typeof arguments[arguments.length-1] =="function" ){
            for(var i=0;i<arguments.length;i++){
                if(typeof arguments[i] =="object" && arguments[i].hasOwnProperty("data")){
                    _data = arguments[i];
                }
            }
            _event = arguments[0];
            _func =arguments[1];
            if(typeof arguments[1]=="string"){
                _event = arguments[0];
                _selector =arguments[1];
                _func =arguments[arguments.length-1];
                for (var i = 0; i < node.length; i++) {

                    node[i].addEventListener(_event, function(e){
                        var target = e.target;
                        var currentTarget = e.currentTarget;
                        var dom = target;

                        while(dom!=document){
                            if(dom.className.indexOf(_selector.split(".")[1]) >=0  || dom.id == _selector.split("#")[1]){
                                e.data = _data;
                                _func.call(target,e);
                                break;
                            }
                            dom = dom.parentNode;
                        }
                        //if(target.className.indexOf(_selector.split(".")[1]) >=0  || target.id == _selector){
                        //    e.data = _data;
                        //    _func.call(target,e);
                        //}

                    })
                }

            }else{
                for (var i = 0; i < node.length; i++) {
                    node[i].addEventListener(_event, function(e){
                        e.data = _data;
                        _func.call(this,e);
                    })
                }
            }

        }




    };
    _$.prototype.removeClass = function (name) {
        var node = this.node;
        for (i = 0; i < node.length; i++) {
            var className = node[i].className;
            if (className.indexOf(name)) {
                className = className.replace(name, "");
                node[i].className = className;
            }
        }
    };
    _$.prototype.addClass = function (name) {
        var node = this.node;
        for (i = 0; i < node.length; i++) {
            var className = node[i].className;
            if (className.indexOf(name) < 0) {
                className += " " + name;
                node[i].className = className;
            }
        }
    };
    _$.prototype.toggleClass =function(name){
        var node = this.node;
        for (i = 0; i < node.length; i++) {
            var className = node[i].className;
            if (className.indexOf(name) < 0) {
                _$.prototype.addClass.apply(this,arguments);
            }else{
                _$.prototype.removeClass.apply(this,arguments);
            }
        }
    };
    _$.prototype.fadeIn = function (speed, delay) {
        var delay = delay || 0;
        var node = this.node;
        for (var i = 0; i < node.length; i++) {
            node[i].style.display = "block";
            node[i].style.opacity = 0;
            (function (n, s, d) {
                setInterval(function () {
                    if (n.style.opacity < 1) {
                        n.style.opacity = parseFloat(n.style.opacity) + 0.1;
                    }
                }, speed);
            })(node[i], speed, delay);


        }

    }
    L.$ = $;
    var Ajax = new L.Class({
        init: function (url, args, method) {
            var xhr = new XMLHttpRequest();

            this.url = url;
            this.method = method || "POST";
            this.xhr = xhr;
            this.args = args || "";
        },
        send: function () {
            var that = this;

            that.xhr.callbacks = that.callbacks;
            that.xhr.onreadystatechange = that.callbacks.processState;

            that.xhr.open(that.method, that.url, true);
            that.xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
            //that.xhr.setRequestHeader("Access-Control-Allow-Origin","*");
            that.xhr.send(that.args);
        },
        callbacks: {
            processState: function (func, obj) {
                return function () {
                    switch (this.readyState) {
                        case 0:
                            break;
                        case 1:
                            break;
                        case 2:
                            break;
                        case 3:
                            break;
                        case 4:
                            if (this.status == 200) {
                                try {
                                    obj.data = JSON.parse(this.response);
                                    obj.data.status = 200;
                                } catch (e) {
                                    throw new Error("JSON.parse方法出错");
                                }
                                func()
                            } else if (this.status = 404) {
                                obj.data = {status:404};
                                func()
                            }
                            break;
                        default:
                            break;
                    }
                }

            },
            success: function () {
                var data = arguments[0];
                return data.response;
            },
            error: function () {

            }
        }

    });

    L.Ajax = Ajax;

    //http模块
    L.http = {
        /**
         * ajax请求
         *
         * @name ajax
         * @function
         * @memberOf L.http
         * @param {Object} option 参数对象(必须)
         * @param {string} option.url 接口名称(必须)
         * @param {*} option.data 请求参数
         * @param {string} option.dataType 返回数据类型
         * @param {string} option.type 请求类型
         * @param {function} option.beforeSend 发送前回调
         * @param {function} option.success 成功回调
         * @param {function} option.error 错误回调
         * @param {function} option.complete 完成回调
         * @param {function} option.success 成功回调
         * @param {boolean} option.async 是否同步
         * @return {Object}  xhr对象
         */
        ajax: function (option) {
            var GetSuccess = function (e) {
                console.log({
                    msg: interfaceUrl + o.url + suffix + "接口调用成功",
                    respCode: e.respCode,
                    memo: e.memo,
                    data: e
                });
            };
            var GerError = function (e) {
                console.log({
                    msg: interfaceUrl + o.url + suffix + "接口调用失败",
                    status: e.status,
                    data: e
                });

            };

            var o = option;

            if ((typeof  o.data) == "string") {
                if (!o.data) {
                    o.data += "terminal=H5";
                } else {
                    o.data = "terminal=H5&" + _data;
                }
            }
            else if ((typeof  o.data) == "object") {
                o.data.terminal = "H5"
            }

            var xhr = $.ajax(
                {
                    url: interfaceUrl + o.url + suffix,
                    type: o.type || "POST",
                    data: o.data,
                    dataType: o.dataType || "JSON",
                    beforeSend: o.beforeSend || currentFundObj.showLoading,
                    success: function (data) {
                        (typeof data == "string") && (data = JSON.parse(data));
                        //data = JSON.parse(data);
                        if (debug == 1) {
                            GetSuccess(data);
                        }
                        if (o.success) {

                            if (data.respCode == "000") {
                                o.success(data);
                            }
                            else {
                                cFundObject.showMsg(data.errorMessage || data.memo || data.respMessage || "未登录或服务暂停，请重试");
                                return false;
                            }
                        }
                    },
                    error: function (data) {
                        if (debug == 1) {
                            cFundObject.showMsg("未登录或服务暂停，请重试");
                            GerError(data);
                        }
                        if (o.error) {
                            o.error(data);
                        }

                    },
                    complete: o.complete || currentFundObj.hiddenLoading,
                    async: o.async || "true"
                });
            return xhr;
        },
        /**
         * 获取url参数方法
         *
         * @name getQueryString
         * @function
         * @memberOf L.http
         * @param {string} name url参数(必须)
         * @return {string}  url参数对应值
         */
        getQueryString: function (name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) return unescape(r[2]);
        },
        getHashString: function () {
            return location.href.split("#")[1];
        },
        getUrlWithoutHash: function () {
            return location.href.split("#")[0];
        }
    };

    /**
     * 页面滚动控件1.0
     *
     * @name scroll
     * @function
     * @memberOf L
     * @param {oject} option 滚动控件参数对象(必须)
     * @param {string} option.ajax ajax请求闭包(废弃)
     * @param {string} option.scrollClass 渲染的类名(必须)
     * @param {string} option.scrollIndexKey ajax参数中控制页数的参数名(必须)
     * @param {string} option.ajaxArgs ajax请求参数(必须)
     * @return {oject}  页面滚动控件对象
     */
    L.scroll = L.Class({
        init: function () {
            var option = arguments[0];
            var that = this;
            that.option = option;

            //ajax请求闭包
            option.ajax = option.ajax || function () {
                };
            option.scrollClass = option.scrollClass || "";
            //默认递增页数请求参数
            option.scrollIndexKey = option.scrollIndexKey || "pageIndex";
            option.ajaxArgs = option.ajaxArgs || {};
            //默认递增页数起始页数
            option["ajaxArgs"]["data"][option.scrollIndexKey] = option["ajaxArgs"]["data"][option.scrollIndexKey] || 1;

            var ajax = function () {
                //alert(option.ajaxArgs.data.pageIndex);
                L.http.ajax({
                    url: option.ajaxArgs.url,
                    data: option.ajaxArgs.data,
                    success: function (data) {
                        //关闭遮罩
                        //currentFundObj.hiddenLoading();
                        option.ajaxArgs.success(data);
                    }
                });
            };
            //默认先载入起始页
            ajax();
            option["ajaxArgs"]["data"][option.scrollIndexKey]++;

            $(document).on('scroll', {scrollClass: option.scrollClass}, function (e) {
                if ($("#menu-" + e.data.scrollClass).hasClass("active")) {
                    var scrollTop = $(window).scrollTop();
                    var scrollHeight = document.body.scrollHeight;
                    var windowHeight = $(window).height();
                    var resizeTimer = null;
                    if (that["option"]["ajaxArgs"]["data"][option.scrollIndexKey]) {
                        if (scrollTop + windowHeight + 80 >= scrollHeight) {

                            //开始遮罩
                            pLoader.show();

                            if (resizeTimer) {
                                clearTimeout(resizeTimer)
                            }
                            resizeTimer = setTimeout(function () {
                                ajax();
                                that["option"]["ajaxArgs"]["data"][option.scrollIndexKey]++;
                            }, 400);
                        }
                    }
                } else {
                    return false;
                }

            });
        },
        stop: function () {
            var option = arguments[0];
            var that = this;

            that["option"]["ajaxArgs"]["data"][that.option.scrollIndexKey] = 0;
        }
    });

    //各类format方法
    L.dateFormat = Date.prototype.format = function (fmt) {
        var o = {
            "M+": this.getMonth() + 1, //月份
            "d+": this.getDate(), //日
            "h+": this.getHours(), //小时
            "m+": this.getMinutes(), //分
            "s+": this.getSeconds(), //秒
            "q+": Math.floor((this.getMonth() + 3) / 3), //季度
            "S": this.getMilliseconds() //毫秒
        };
        if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
        for (var k in o)
            if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
        return fmt;
    };

    //路由模块
    L.Router = L.Class({
        init: function () {
            var args = arguments;
            var that = this;
            that.routes = args[0];
        },
        config: function () {
            var option = arguments;
            var that = this;
            that.root = option[0].root;
        },
        on: function () {
        },
        start: function () {
            var args = arguments;
            var that = this;
            var routes = that.routes;
            var root = that.routes.root || Object.getOwnPropertyNames(that.routes)[0] || "";


            var fnHashTrigger = function (target) {
                var query = L.http.getHashString();

                if (typeof query == "undefined") {
                    //没有指定Hash
                    history.replaceState(null, "基金名称", location.href + "#" + root);

                    fnHashTrigger();
                } else {
                    if (query in that.routes) {

                        var hasHistory = false;
                        for (var i in L.Router.history) {
                            if (query == L.Router.history[i]) {
                                hasHistory =true;
                                break;
                            }
                        }
                        var pageDom, pageContentDom,oldDom;
                        if(hasHistory){
                            L.Router.history.pop();

                            if (document.querySelector(".pages").childElementCount == 1) {

                                pageContentDom = document.createElement("div");
                                pageContentDom.className = "page-content";
                                //pageContentDom.innerHTML = template(tpl, model.data);

                                pageDom = document.createElement("div");
                                pageDom.className = "page page-from-left-to-center";
                                pageDom.setAttribute("data-page",query);
                                pageDom.appendChild(pageContentDom);
                                pageDom.addEventListener("webkitAnimationEnd", function () {
                                    pageDom.className = "page page-on-center";
                                });
                                document.querySelector(".pages").insertBefore(pageDom, document.querySelectorAll(".page")[0]);

                                oldDom = document.querySelector(".pages").lastChild;
                                oldDom.className = "page page-from-center-to-right";
                                oldDom.addEventListener("webkitAnimationEnd", function () {
                                    document.querySelector(".pages").removeChild(oldDom);
                                });

                            }
                            else if(document.querySelector(".pages").childElementCount == 2) {
                                oldDom = document.querySelector(".pages").lastChild;
                                oldDom.className = "page page-from-center-to-right";
                                oldDom.addEventListener("webkitAnimationEnd", function () {
                                    document.querySelector(".pages").removeChild(oldDom);
                                });

                                pageContentDom = document.createElement("div");
                                pageContentDom.className = "page-content";
                                //pageContentDom.innerHTML = template(tpl, model.data);

                                pageDom = document.createElement("div");
                                pageDom.className = "page page-from-left-to-center";
                                pageDom.setAttribute("data-page",query);
                                pageDom.appendChild(pageContentDom);
                                pageDom.addEventListener("webkitAnimationEnd", function () {
                                    pageDom.className = "page page-on-center";
                                });
                                document.querySelector(".pages").replaceChild(pageDom, document.querySelectorAll(".page")[0]);
                            }


                        }/*else{
                            L.Router.history.push(query);

                            if (document.querySelector(".pages").childElementCount < 1) {
                                pageContentDom = document.createElement("div");
                                pageContentDom.className = "page-content";
                                //pageContentDom.innerHTML = template(tpl, model.data);

                                pageDom = document.createElement("div");
                                pageDom.className = "page";
                                pageDom.appendChild(pageContentDom);
                                pageDom.setAttribute("data-page",query);
                                document.querySelector(".pages").appendChild(pageDom);
                            } else if (document.querySelector(".pages").childElementCount == 1) {
                                //document.querySelectorAll(".page")[0].className ="page page-on-left";
                                document.querySelectorAll(".page")[0].className = "page page-from-center-to-left";
                                document.querySelectorAll(".page")[0].addEventListener("webkitAnimationEnd", function () {
                                    document.querySelectorAll(".page")[0].className = "page page-on-left";
                                });

                                pageContentDom = document.createElement("div");
                                pageContentDom.className = "page-content";

                                pageDom = document.createElement("div");
                                pageDom.className = "page page-from-right-to-center";
                                pageDom.setAttribute("data-page",query);
                                pageDom.appendChild(pageContentDom);
                                pageDom.addEventListener("webkitAnimationEnd", function () {
                                    pageDom.className = "page page-on-center";
                                });
                                document.querySelector(".pages").appendChild(pageDom);
                            } else if (document.querySelector(".pages").childElementCount == 2) {
                                document.querySelector(".pages").removeChild(document.querySelectorAll(".page")[0]);

                                document.querySelectorAll(".page")[0].className = "page page-from-center-to-left";
                                document.querySelectorAll(".page")[0].addEventListener("webkitAnimationEnd", function () {
                                    document.querySelectorAll(".page")[0].className = "page page-on-left";
                                });

                                pageContentDom = document.createElement("div");
                                pageContentDom.className = "page-content";

                                pageDom = document.createElement("div");
                                pageDom.className = "page page-from-right-to-center";
                                pageDom.setAttribute("data-page",query);
                                pageDom.appendChild(pageContentDom);
                                pageDom.addEventListener("webkitAnimationEnd", function () {
                                    pageDom.className = "page page-on-center";
                                });
                                document.querySelector(".pages").appendChild(pageDom);

                            }
                        }*/
                        routes[query]();

                    } else {
                        history.replaceState(null, "基金名称", L.http.getUrlWithoutHash() + "#" + root);
                        fnHashTrigger();
                    }
                }

            };

            if (history.pushState) {
                window.addEventListener("popstate", function () {
                    //nextPage(9)
                    fnHashTrigger();
                });
                // 默认载入
                fnHashTrigger();
            } else {
                console.log("当前浏览器不支持pushState,需做降级处理")
            }
        }
    });
    //Router的history
    L.Router.history = [];

    var models = {};

    var Model = function (name, option) {

        if (!models[name]) {
            this.name = name || "model" + new Date().getTime();
            this.modelAjax = {};
            this.option = option;
            this.option.encrypt =this.option.encrypt || "App";

            if(this.option.encrypt == "App"){
                var argsObj = {
                    "terminal":"H5",
                    "saleMercId": "LD",
                    "reqTime": (function(){return new Date().toUTCString()})(),
                    "accessTerminal": "H5",
                    "channelCode": "LD",
                    "clientVersion": "3.1.1",
                    "ext": null,
                    "functionCode": null,
                    "token": "",
                    "version": "1.0"};
                for(var key in option.args){
                    if(option.args.hasOwnProperty(key)){
                        argsObj[key] =option.args[key];
                    }
                }
                var encodeArgs = cFundObjects.encrypts(JSON.stringify(argsObj));
                option.args =  "data=" +encodeArgs;
            }else if(this.option.encrypt == "M"){
                option.args = option.args;
            }



            option.url =  interfaceUrl+ option.url || "";

            //默认关闭loading
            option.loading = option.loading || false;

            this.request();
            models[name] = this;
        } else {
            return models[name]
        }
    };
    Model.prototype = {
        constructor: this,
        request: function () {
            this.option.loading && cFundObject.showLoading();

            var modelAjax = new L.Ajax(this.option.url,this.option.args,this.option.method);
            modelAjax.send();

            this.modelAjax = modelAjax;
        },
        ready: function (func) {

            if (this.modelAjax.xhr.readyState == 4 && this.modelAjax.xhr.status == 200) {
                func();
            } else {
                this.modelAjax.xhr.onreadystatechange = L.Ajax.prototype.callbacks.processState(func, this);
            }

        }
    };

    var View = L.Class({
        init: function (model, tpl) {
            this.model = model;
            this.tpl = tpl;
        },
        show: function () {
            var model = this.model;
            var tpl = this.tpl;
            //重置滚动条
            window.scrollTo(0, 0);
            //var pageDom, pageContentDom;
            //if (document.querySelector(".pages").childElementCount < 1) {
            //    pageContentDom = document.createElement("div");
            //    pageContentDom.className = "page-content";
            //    pageContentDom.innerHTML = template(tpl, model.data);
            //
            //    pageDom = document.createElement("div");
            //    pageDom.className = "page";
            //    pageDom.appendChild(pageContentDom);
            //    document.querySelector(".pages").appendChild(pageDom);
            //} else if (document.querySelector(".pages").childElementCount == 1) {
            //    //document.querySelectorAll(".page")[0].className ="page page-on-left";
            //    document.querySelectorAll(".page")[0].className = "page page-from-center-to-left";
            //    document.querySelectorAll(".page")[0].addEventListener("webkitAnimationEnd", function () {
            //        document.querySelectorAll(".page")[0].className = "page page-on-left";
            //    });
            //
            //    pageContentDom = document.createElement("div");
            //    pageContentDom.className = "page-content";
            //    pageContentDom.innerHTML = template(tpl, model.data);
            //
            //    pageDom = document.createElement("div");
            //    pageDom.className = "page page-from-right-to-center";
            //    pageDom.appendChild(pageContentDom);
            //    pageDom.addEventListener("webkitAnimationEnd", function () {
            //        pageDom.className = "page page-on-center";
            //    });
            //    document.querySelector(".pages").appendChild(pageDom);
            //} else if (document.querySelector(".pages").childElementCount == 2) {
            //
            //    var oldDom = document.querySelector(".pages").lastElementChild;
            //    oldDom.className = "page page-from-center-to-right";
            //    oldDom.addEventListener("webkitAnimationEnd", function () {
            //        document.querySelector(".pages").removeChild(oldDom);
            //    });
            //
            //    pageContentDom = document.createElement("div");
            //    pageContentDom.className = "page-content";
            //    pageContentDom.innerHTML = template(tpl, model.data);
            //
            //    pageDom = document.createElement("div");
            //    pageDom.className = "page page-from-left-to-center";
            //    pageDom.appendChild(pageContentDom);
            //    pageDom.addEventListener("webkitAnimationEnd", function () {
            //        pageDom.className = "page page-on-center";
            //    });
            //    document.querySelector(".pages").replaceChild(pageDom, document.querySelectorAll(".page")[0]);
            //
            //}

            document.querySelector('[data-page="'+tpl+'"]').firstElementChild.innerHTML =template(tpl,model.data);

            //document.querySelector("#center").innerHTML = template(tpl, model.data);
            this.model.option.loading && currentFundObj.hiddenLoading();
        }
    });
    L.MVC = {};
    L.MVC.Model = Model;
    L.MVC.models = models;
    L.MVC.View = View;


    var addEvent = function () {

        var type = arguments[0];
        var func = arguments[1];
        this._listener = {};
        this._listener[type] = [];
        this._listener[type].push(func);

    };
    var triggerEvent = function () {
        var type = arguments[0];
        this._listener[type]();
    };
    L.Event = {};
    L.Event.addEvent = addEvent;
    L.Event.triggerEvent = triggerEvent;

    var clone = function (obj) {
        if (obj instanceof Object) {
            var copy = {};
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    copy[key] = clone(obj[key]);
                }
            }
            return copy;
        } else if (obj instanceof Array) {
            var array = [];
            for (var i = 0; i < obj.length; i++) {
                array[i] = clone(obj[i]);
            }
            return array;
        } else {
            return obj;
        }
    };
    L.clone = clone;


});


